const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const newsletter_subscriptions = sequelize.define(
    'newsletter_subscriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

email: {
        type: DataTypes.TEXT,
      
      

      },

is_confirmed: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

subscribed_at: {
        type: DataTypes.DATE,
      
      

      },

unsubscribed_at: {
        type: DataTypes.DATE,
      
      

      },

source: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  newsletter_subscriptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.newsletter_subscriptions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.newsletter_subscriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.newsletter_subscriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return newsletter_subscriptions;
};


